article

laurenceh avatar image
laurenceh posted

How to: Quickly update RPI Touch Screen configuration on new SD card or after version update.

I have created a scripted menu to enable me to quickly update a new Venus OS SD image installed on an SD card. I thought the community might find it useful.

What's the use case?

If I am going to test new release or intermediate version of Venus OS on my RPI 3B+ I want to be able to quickly configure the touch screen and other interfaces when I set up a new card. It is possible to store changes you want on the /data partition of a Venus OS Rpi SD card but getting at SD cards mounted in the touch screen case is tricky as it involves disassembling the Rpi and screen case. So I wanted to do this using an USB memory stick which is easy to insert and remove.

Also I'm dreadful at typing accurately when I'm eager to try out a new feature so this script does all the typing for me and checks the errors that might occur and tells me about them.

What does this do ?

It enables quick configuration of a new Venus OS install to support:

  • 7" Touch screen (800x480 or 480x272)
  • Screen rotation dependent on how you are going to mount it
  • Headless on and off (needed for calibration)
  • Calibrate touch screen
  • Enable mcp3208 analogue interface on Sio (as per Venus GX)
  • Screen backlight dimming
  • Screen auto power off
  • Enable i2c interface
  • Enable the inbuilt Venus OS Web server to serve python scripts

The script is interactive and incorporates everything I have gleaned from other posts in this forum and in other places on the internet. I have written most of the logic out long hand and using if-then-else and case statements without too many obscure code contractions - it could easily be significantly reduced in size but would probably be less readable or maintainable by others if It was.

Here's an example of what it looks like:


The full script is included below. Quite a bit of it works stand alone and uses the necessary wget and opkg installs to pull the right modules and packages from the internet. There are some items I have not been able to find on the internet and these need to be in a directory called 'restore' in the same directory as the script.

These resources are:

/restore/mcp3208-overlay.dtb

/restore/rpi-backlight-overlay.dtb

/restore/dbus-adc

/restore/start-gui-800x480.sh

/restore/start-gui-480x272.sh

The script has been tested as I use it, so I have confirmed that no other lines, programmes, commands or resources are needed for this work on a Venus OS Rpi.

I have created a zip file with these resources and including the script file, the zip file is available on my own web server here. (the version of the script in the zip image is out of date the version in the article her is up to date (5/5/2020).

How to use it:

Download the zip file put it on a USB memory stick.

Plug this into your Venus OS RPi and locate the memory stick which will be something like : /run/media/sda1

the exact device will depend on where you plug it in.

Open the storage device:

  1. cd /run/media/sda1
  1. unzip venus-rpi.zip

Unzipping on the target machine (not on a MAC or windows PC) should preserve the file setting and attributes well enough for the purpose here.

  1. cd venus-rpi-setup

Run the script

  1. ./setup-menu.sh


  1. #!/bin/sh
  2. # sample.mnu
  3. # Menu to allow selected setup of rasperry pi features on Venus os install.
  4. # This currently assumes you want to use the official Raspberry pi 7" screen
  5. #
  6. # this is written in a structured manner but is written long hand
  7. # without fancy lopps, arrays, or constructions the rational for this is
  8. # to enable others to extend, modify and debug it without too much obscure code
  9. #
  10. #------------------------------------------------------
  11. # MENU FUNCTION DEFINITIONS
  12. #------------------------------------------------------  
  13. # define a function to highlight the choice
  14. #
  15. # funtion defined to mark the chosen function in the menu display
  16. mark () {
  17. if [ "${answer^}" = "$1" ] ; then echo -n "* " ; marked=1 ; else echo -n "  " ; fi }
  18. #
  19. # Define a function for invalid menu picks
  20. # The function loads an error message into a variable
  21. badchoice () { MSG="Invalid Selection ... Please Try Again" ; }
  22.  
  23. # For each prompt displayed, there is a list of
  24. # commands to execute in response to the user picking the
  25. # associated letter. Each is defined as a function.
  26. # Eech function defines the list of actions to be executed,
  27. # and attempts to catch possible common errors.
  28.  
  29. execute () {
  30. #echo "execute entered with" $1
  31.   case $1 in
  32.      H) headless;;
  33.      O) headlessoff;;
  34.      D) displayDrivers;;
  35.      U) upsidedown ;;
  36.      8) changeto800;;
  37.      4) changeto480;;
  38.      S) dimming;;
  39.      T) timer;;
  40.      A) analogue;;
  41.      I) i2c;;
  42.      R) systemreboot;;
  43.      P) webpython ;;
  44.      C) calibrate;;
  45.      Q) exit;;
  46.  
  47.        *) badchoice;;
  48. esac
  49. echo "action complete press any key to continue"
  50. read -rsn 1 jim
  51. MSG=""
  52. }
  53.  
  54. headless () {
  55. if [ -f /etc/venus/headless.off ]; then
  56.  echo "headless is off - switching to headless"
  57.  mv /etc/venus/headless.off /etc/venus/headless
  58.  REBOOT=1
  59. else
  60.  if [ -f /etc/venus/headless ]; then
  61.  echo "headless already configured - no change made"
  62.  else
  63.  echo "no headless configuration found - enabling headless"
  64.  touch /etc/venus/headless
  65.  REBOOT=1
  66.  fi
  67. fi ; }
  68.  
  69. headlessoff () {
  70. if [ -f /etc/venus/headless ]; then
  71.  echo "headless is enabled - switching to headless off"
  72.  mv /etc/venus/headless /etc/venus/headless.off
  73.  REBOOT=1
  74. else
  75.  if [ -f /etc/venus/headless.off ]; then
  76.  echo "headless already off - no change made"
  77.  else
  78.  echo "no headless configuration found - switching headless off"
  79.  touch /etc/venus/headless.off
  80.  REBOOT=1
  81.  fi
  82. fi ; }
  83.  
  84. displayDrivers () {
  85. echo "This will execute opkg commands, an internet connection is required do you have one (y/n)?"
  86. read -s -N 1 key
  87. case $key in
  88.   y|Y)
  89.   echo "Package install will continue"
  90.   echo "opkg update"
  91.     opkg update 2>&1
  92.   echo "install mousedriver"
  93.     opkg install qt4-embedded-plugin-mousedriver-tslib 2>&1
  94.   echo "install-tslib-calibrate"
  95.     opkg install tslib-calibrate 2>&1
  96.   echo "install tslib-conf"
  97.     opkg install tslib-conf 2>&1
  98.   echo "install tslib-tests"
  99.     opkg install tslib-tests 2>&1
  100. # update config.txt
  101.   echo "Upating config.txt"
  102.     grep -q 'framebuffer_width=[0-9][0-9][0-9]' /u-boot/config.txt
  103.     if [ $? -eq 0 ] ; then
  104.       echo "Frame buffer already configured in config.txt no change made"
  105.     else
  106.       echo 'framebuffer_width=800' >> /u-boot/config.txt
  107.       echo 'framebuffer_height=480' >> /u-boot/config.txt
  108.       echo "Config.txt file updated"
  109.     fi
  110.   REBOOT=1
  111.   ;;
  112.   *)
  113.   echo "Cannot proceed without internet connection"
  114.   ;;
  115. esac ; }
  116.  
  117. changeto800 () {
  118.   echo "install replacement start GUI file"
  119.     cp -p $dir/restore/start-gui-800x480.sh /opt/victronenergy/gui/start-gui.sh 2>&1
  120.     if [ $? -eq 0 ] ; then
  121.       echo "installed modified strat-gui.sh file"
  122.     else
  123.       echo "failed to install modified start-gui.sh file"
  124.     fi
  125.   echo "Upating config.txt"
  126.     grep -q 'framebuffer_width=[0-9][0-9][0-9]' /u-boot/config.txt
  127.     if [ $? -eq 0 ] ; then
  128.       sed -i 's/framebuffer_width=[0-9][0-9][0-9]/framebuffer_width=800/' /u-boot/config.txt
  129.       sed -i 's/framebuffer_height=[0-9][0-9][0-9]/framebuffer_height=480/' /u-boot/config.txt
  130.       echo "Config.txt file updated"
  131.     else
  132.      echo "Frame buffer config not found in config.txt no change made"
  133.     fi
  134.     echo "remember to recalibrate the touch screen if you have changed screen size"
  135.     REBOOT=1 ; }
  136.  
  137.  
  138. changeto480 () {
  139.   echo "install replacement start GUI file"
  140.     cp -p $dir/restore/start-gui-480x272.sh /opt/victronenergy/gui/start-gui.sh 2>&1
  141.       if [ $? -eq 0 ] ; then
  142.          echo "Installed modified start-gui.sh file"
  143.       else
  144.          echo "failed to install modified start-gui.sh file"
  145.       fi
  146.   echo "Upating config.txt"
  147.     grep -q 'framebuffer_width=[0-9][0-9][0-9]' /u-boot/config.txt
  148.     if [ $? -eq 0 ] ; then
  149.       sed -i 's/framebuffer_width=[0-9][0-9][0-9]/framebuffer_width=480/' /u-boot/config.txt
  150.       sed -i 's/framebuffer_height=[0-9][0-9][0-9]/framebuffer_height=272/' /u-boot/config.txt
  151.       echo "Config.txt file updated"
  152.     else
  153.      echo "Frame buffer configuration not found in config.txt no change made"
  154.     fi
  155.      echo "remember to recalibrate the touch screen if you have changed screen size"
  156.     REBOOT=1 ; }
  157.  
  158. calibrate () {
  159. echo "Make sure headless is enable and the system rebooted - you can't calibrate a screen with the GUI on"
  160.  echo "If the screen blanking time has switched off the screen."
  161.  echo "You can still change this by accessing the Venus OS GUI remote console with a browser"
  162.  echo "ready to start calbration (y/n)?"
  163.  read -s -N 1 key
  164.  case $key in
  165.  y|Y)
  166.    TSLIB_FBDEVICE=/dev/fb1
  167.    TSLIB_TSDEVICE=/dev/input/touchscreen0 ts_calibrate
  168.  ;;
  169.  *)
  170.  echo "Calibration aborted - no changes made"
  171.  ;;
  172. esac ; }
  173.  
  174. dimming () {
  175. echo "This will execute wget and opkg commands, an internet connection is required do you have one (y/n)?"
  176. read -s -N 1 key
  177. case $key in
  178.   y|Y)
  179.   echo "Overlay install will continue"
  180.   echo "/sys/class/backlight/rpi_backlight" > /etc/venus/backlight_device
  181.   if [ -f /u-boot/overlays/rpi-backlight-overlay.dtb ] ; then
  182.     echo "backlight dtb overlay already exists - this will not be replaced"
  183.   else
  184.     echo "fetching overlay file"
  185.     wget https://github.com/PiNet/PiNet-Boot/raw/master/boot/overlays/rpi-backlight-overlay.dtb 2>&1
  186.     echo $dir/rpi-backlight-overlay.dtb
  187.     mv $dir/rpi-backlight-overlay.dtb /u-boot/overlays
  188.    fi
  189.    echo "fetching kernel module"
  190.     opkg install kernel-module-rpi-backlight 2>&1
  191.   REBOOT=1
  192.   ;;
  193.   *)
  194.   echo "No changes made without internet connection"
  195.   # an alternatie might be to install a copy of the overlay from the /data/recover directory
  196.   ;;
  197. esac ; }
  198.  
  199. timer () {
  200. echo "/sys/class/backlight/rpi_backlight/bl_power" > /etc/venus/blank_display_device
  201. }
  202.  
  203. analogue () {
  204.   if [ -f /u-boot/overlays/mcp3208-overlay.dtb ]; then
  205.      echo "mcp3208 overlay file already exists no change made"
  206.   else
  207.      cp -p $dir/restore/mcp3208-overlay.dtb /u-boot/overlays
  208.      if [ $? -eq 0 ] ; then
  209.        echo "mcp3208 overlay file installed"
  210.      else
  211.        echo "Failed to install mcp3208 overlay file"
  212.      fi
  213.   REBOOT=1
  214.   fi
  215.   if [ -d //opt/victronenergy/dbus-adc ]; then
  216.      echo "dbus-adc device interfaces already exist no changes made to drivers"
  217.   else
  218.      cp -pr $dir/restore/dbus-adc /opt/victronenergy
  219.      if [ $? -eq 0 ] ; then
  220.         echo "dbus-adc service files installed in /opt/victronenergy"
  221.      else
  222.         echo "Failed install dbus-service files"
  223.      fi
  224.   REBOOT=1
  225.   fi
  226.  
  227.   grep -q 'dtoverlay=mcp3208:spi0-0-present' /u-boot/config.txt
  228.   if [ $? -eq 0 ] ; then
  229.       echo "config.txt alread configured for MCP3208 analogue interface no changes made to config.txt"
  230.   else
  231.       echo 'dtoverlay=mcp3208:spi0-0-present' >> /u-boot/config.txt
  232.       echo "Config.txt updated for analogue interface"
  233.   fi
  234.   touch /var/log/dbus-adc
  235.   ln -s /opt/victronenergy/dbus-adc/service /service/dbus-adc
  236.   REBOOT=1 ; }  
  237.  
  238. i2c () {
  239.   grep -q 'dtparam=i2c_arm=on' /u-boot/config.txt
  240.   if [ $? -eq 0 ] ; then
  241.       echo "config.txt alread configured for i2c interface no changes made to config.txt"
  242.   else
  243.       echo 'dtparam=i2c_arm=on' >> /u-boot/config.txt
  244.       echo "Config.txt updated for i2c interface"
  245.   REBOOT=1
  246.   fi
  247.  
  248.   grep -q 'modprobe i2c-dev' /data/rc.local
  249.   if [ $? -eq 0 ] ; then
  250.       echo "rc.local already configured to start i2c interface no changes made to rc.local"
  251.   else
  252.       echo 'modprobe i2c-dev' >> /data/rc.local
  253.       chmod +x /data/rc.local
  254.       echo "/data/rc.local updated for i2c interface"
  255.   REBOOT=1
  256.   fi ;  }
  257.  
  258. systemreboot () {
  259. #crafty way of shutting down the script while rebooting
  260. exec reboot
  261. }
  262.  
  263. upsidedown () {
  264.   grep -q "lcd_rotate=2" /u-boot/config.txt
  265.   if [ $? -eq 0 ] ; then
  266.     echo "Screen is already inverted reverto no normal (y/n)"
  267.     read -s -N 1 key
  268.     case $key in
  269.       y|Y)
  270.       sed -i 's/lcd_rotate=2//' /u-boot/config.txt
  271.     ;;
  272.     *)
  273.       echo "No change made"
  274.     ;;  
  275.     esac
  276.   else
  277.     echo "Configureing /u-boot/config.txt to invert screen"
  278.     echo "lcd_rotate=2" >> /u-boot/config.txt
  279.    fi ; }
  280.  
  281. webpython () {
  282.   grep -q "CGIhandler = /usr/bin/python:py" /etc/hiawatha/hiawatha.conf
  283.   if [ $? -eq 0 ] ; then
  284.     sed -i 's%#CGIhandler = /usr/bin/python:py%CGIhandler = /usr/bin/python:py%' /etc/hiawatha/hiawatha.conf
  285.     echo "/usr/bin/python:py updated to enable python"
  286.   else
  287.     echo "File or CGIhandler configuration missing in /etc/hiawatha/hiawatha.conf - no changes made"
  288.   fi
  289. REBOOT=1 ; }
  290.  
  291. #------------------------------------------------------
  292. # DISPLAY MENU
  293. #------------------------------------------------------
  294. # This function displays the menu.
  295. # The routine clears the screen, echoes
  296. # the menu prompts and any additional messages.
  297. # Note that this definition does not cause the menu to
  298. # be executed, it just defines, it ready to be executed.
  299.  
  300. themenu () {
  301. # clear the screen
  302. clear
  303. echo `date`
  304. echo
  305. echo -e "\t Venus os Raspberry pi configure functions"
  306. echo
  307. echo -e "\t\t\t Please Select"
  308. echo -e $(dirname $0)
  309. marked=0
  310. #
  311. # this line is a placeholder for a function which calls most of the other functions - not yet implemented
  312. #echo -en "\t\t\t" ; mark E ; echo "(E)verything (i2c, Analogue, Headless, 800x400, except calibrate screen) " ;
  313. #
  314. echo -en "\t\t\t" ; mark H ; echo "(H)eadless - used when calibrating ";
  315. echo -en "\t\t\t" ; mark O ; echo "(O) Headless (O)ff - enable RPI Screen ";
  316. echo -en "\t\t\t" ; mark D ; echo "(D)isplay drivers 800x480  ";
  317. echo -en "\t\t\t" ; mark C ; echo "(C)alibrate touch screen   ";
  318. echo -en "\t\t\t" ; mark U ; echo "(U)pside down touch screen ";
  319. echo -en "\t\t\t" ; mark 8 ; echo "(8) change to 800x480 resolution  ";
  320. echo -en "\t\t\t" ; mark 4 ; echo "(4) change to 480x272 resolution  ";
  321. echo -en "\t\t\t" ; mark S ; echo "(S)creen dimming interface        ";
  322. echo -en "\t\t\t" ; mark T ; echo "(T)imer display shut off          ";
  323. echo -en "\t\t\t" ; mark A ; echo "(A)nalogue mcp3208 spi interface drivers ";
  324. echo -en "\t\t\t" ; mark I ; echo "(I)2c enable i2c interfaces       ";
  325. echo -en "\t\t\t" ; mark R ; echo "(R)eboot Venus OS                 ";
  326. echo -en "\t\t\t" ; mark P ; echo "(P) Web server: enable (P)ython scripts  ";
  327. echo -en "\t\t\t" ; mark Q ; echo "(Q)uit                     ";
  328. echo
  329. ((!marked)) &&  badchoice # flag up bad selections
  330. echo $MSG
  331. ((REBOOT)) && echo "A reboot will be required to implement changes" || echo
  332.  
  333. echo
  334. echo "Select by pressing the letter and then ENTER to execute commands";
  335. }
  336.  
  337. #------------------------------------------------------
  338. # MAIN EXECUTION
  339. #------------------------------------------------------
  340. # Clear out the error
  341. MSG=
  342. # changes to true iff we do somthoing that needs a reboot
  343. REBOOT=0
  344. # find out where we are
  345. dir=$(dirname $0)
  346. # Repeat the menu over and over
  347. # Steps are:
  348. # 1. Display the menu
  349. # 2. 'read' a key of input from the key board
  350. # 3. Clear the error message
  351. # 4. if the user pressed return dispatch valid entries for execution
  352. #    to the appropriate function or exit
  353. # 5. Set error message for invalid options
  354.  
  355. while  true
  356. do
  357. # 1. display the menu by calling the function
  358. #    this includes display the last error mesaage if ther is one
  359.  themenu
  360.  
  361. # 2. read a character of input from the keyboard by a command
  362. read -s -N 1 key
  363.  
  364. # 3. Clear any error message
  365.   MSG=
  366. #
  367. #if they press [ENTER]  then go and do it
  368. if [[ "$key" == $'\x0a' ]] ; then
  369.  execute "$answer"
  370.  
  371. else
  372. #
  373. # They did not press return so remember the key they pressed
  374. #
  375. answer=${key^} # make sure answer is upper case to aid case statements
  376. #     Do it again until the user selects the exit option
  377. fi
  378. done

This was developed against Venus OS 2.42 and test against Venus OS 2.51 today 2nd March 2020.

Venus OSRaspberry Pi
23 comments
2 |3000

Up to 8 attachments (including images) can be used with a maximum of 190.8 MiB each and 286.6 MiB total.

pau1phi11ips avatar image pau1phi11ips commented ·

Excellent work!

I think this should be included in the Victron image as standard.

0 Likes 0 ·
pau1phi11ips avatar image pau1phi11ips pau1phi11ips commented ·

Not sure how possible it would be, but could this script save what settings had been applied and build those into the rc.local file so they survived an update?

Could maybe save the screen calibration settings too?

0 Likes 0 ·
laurenceh avatar image laurenceh pau1phi11ips commented ·

Paul - the answer is probably -

As a next step I was going to look at giving the program a command line interface something like :

Setup-menu.sh -dh8stia

Then this single line added to the rc.local would invoke the setting you want to implement (the interactive version could even add the line to rc.local). Doing it this way would ensure there was only one code base to fix bugs in. I also wanted to keep the interactive interface for the calibration steps and when I want to check for any changes in behaviour new Venus releases.

I was however thinking that if something like this was going to be added to the venus image then I would re-write it as a python web interface (with a similar overall design). This would mean that you could configure by simply going to [Venus IP address]/rpi-config.py. This avoids the root access, ssh, and cli steps which are the things most likely to trip up a linux novice when they want to configure a Venus Rpi. But that's a whole new project.

BTW there are a couple of bugs in the script (text not logic) I'm just going to edit in the fixes.

0 Likes 0 ·
Mark avatar image Mark commented ·

Thats awesome thank you.

0 Likes 0 ·
laurenceh avatar image laurenceh Mark commented ·

Following use of the script through a couple of firmware updates I have just corrected a minor bug in the timer section in the listing above.

echo "/sys/class/backlight/bl_power" > /etc/venus/blank_display_device

should read

echo "/sys/class/backlight/rpi_backlight/bl_power" > /etc/venus/blank_display_device

This has been corrected in the version of the script in the article above.

0 Likes 0 ·
Mark avatar image Mark laurenceh commented ·

@Laurence Thanks.

Have you see my post on previous thread where you link to your article? I'm loosing my marbles lol trying to do the rc.local way so its automated but just can't seem to get it to work grrr

0 Likes 0 ·
mp1234 avatar image mp1234 commented ·

Hello.

i have problems to install the MCP3208 on the pi.

Ich have test it manually, und now also with your script. but i can´t see the analog valus in the menu. i got always this message:

root@raspberrypi2:~# opkg install kernel-module-mcp320x
no packages installed or removed

Can someone give me information what is wrong?


Thank You

0 Likes 0 ·
Rob Duthie avatar image Rob Duthie mp1234 commented ·

Hi

You will have to install this package as well as the analog setting screen gets updated with missing files etc.

Normal operation it will be there, do you have the mcp3208 overlay installed the correct version with the 12 bit conversion done to it.

What ver of venus are you running? as ver >2.60.66 you can't use the analog anymore all being changed when they updated from Rocko to Zeus.

Ver <2.6.66 is still OK and all runs OK.

https://github.com/stgnet/victron-gui-qml/blob/main/PageSettingsIo.qml

Regards

Rob D

NZ

0 Likes 0 ·
mp1234 avatar image mp1234 Rob Duthie commented ·

i have install this Version:

venus-image-raspberrypi2-20200906135923-v2.60.rootfs.rpi-sdimg.zip 2020-09-06 20:10 95M

where i can see the different version. i only can see V2.60.

When i select the script to install the mcp3208 then the pakage will automaticaly installed? or i must do it by my self?

it is important that the mcp3208 is right connected to the PI?? When there is a problem the values are 0. or there are no Signal at he analog input menu?

0 Likes 0 ·
Show more comments
Show more comments
interestingfellow avatar image interestingfellow commented ·

First, THANK YOU!
But also, I can't get the slider to come up in my gui. I can go to /sys/devices/platform/rpi_backlight/backlight/rpi_backlight and manually change the value in "brightness" and the screen responds; I just don't have the handy dandy slider on my rpi venusos screen. What did I do wrong? V2.73

0 Likes 0 ·
w15p avatar image w15p commented ·

Just wanted to thank you for this. I installed and ran this against a venus-image-raspberrypi2-20220215233923-v2.84.rootfs.wic.gz install on a rasp-pi3 and it works fabulously. I haven't yet experimented with the spi/i2c or python web interface but will shortly.

0 Likes 0 ·

Article

Contributors

LaurenceH contributed to this article